<div class="grid-container">
  <div *ngFor="let row of cells | chunk: 16; let rowIndex = index" class="grid-row">
    <div class="row-address">{{ getRowAddress(rowIndex) }}</div>
    <div class="grid">
      <div
        *ngFor="let cell of row; let cellIndex = index"
        class="cell"
        [class.spaced]="cellIndex === 8"
        [class.marked]="markedCells.has(rowIndex * 16 + cellIndex)"
        [class.correct]="correctCells.has(rowIndex * 16 + cellIndex)"
        [class.false]="falseCells.has(rowIndex * 16 + cellIndex)"
        (mousedown)="onMouseDown(rowIndex * 16 + cellIndex)"
        (mouseenter)="onMouseEnter(rowIndex * 16 + cellIndex)"
        [title]="'0x' + cellIndex.toString(16).toLowerCase()"
      >
        {{ cell }}
      </div>
    </div>
  </div>
</div>
